#ifndef EFL_UI_CLICKABLE_EO_HH
#define EFL_UI_CLICKABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_clickable.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace ui { 
struct Clickable;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Clickable> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace ui { 
struct Clickable {
   static Eo_Class const* _eo_class()
   {
      return EFL_UI_CLICKABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::Clickable() const;
   operator ::efl::ui::Clickable&();
   operator ::efl::ui::Clickable const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Clickable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Clickable const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Clickable : ::efl::eo::concrete
{
   explicit Clickable( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Clickable(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Clickable(Clickable const& other) = default;
   Clickable(Clickable&& other) = default;
   Clickable& operator=(Clickable const& other) = default;
   Clickable& operator=(Clickable&& other) = default;
   Clickable()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Clickable( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Clickable(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return EFL_UI_CLICKABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct clicked_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_CLICKED; }
      typedef void parameter_type;
   } const clicked_event;
   static struct clicked_double_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_CLICKED_DOUBLE; }
      typedef void parameter_type;
   } const clicked_double_event;
   static struct clicked_triple_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_CLICKED_TRIPLE; }
      typedef void parameter_type;
   } const clicked_triple_event;
   static struct clicked_right_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_CLICKED_RIGHT; }
      typedef void parameter_type;
   } const clicked_right_event;
   static struct pressed_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_PRESSED; }
      typedef void parameter_type;
   } const pressed_event;
   static struct unpressed_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_UNPRESSED; }
      typedef void parameter_type;
   } const unpressed_event;
   static struct longpressed_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_LONGPRESSED; }
      typedef void parameter_type;
   } const longpressed_event;
   static struct repeated_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_REPEATED; }
      typedef void parameter_type;
   } const repeated_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Clickable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Clickable const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Clickable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Clickable>::value, "");
} } 
#include "efl_ui_clickable.eo.impl.hh"
#endif
